<?php

/*

 $Id: ip_block.php,v 1.9 2004/05/26 20:58:56 philips Exp $
 $Source: /tmp/maintain/modules/class/ip_block.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

 /**
 * ip_block.php - defines the @see IPBlock class 
 * @version $Id: ip_block.php,v 1.9 2004/05/26 20:58:56 philips Exp $
 * @copyright Copyright (c) 2004 Oregon State University - Network Engineering
 * @filesource
 */


/**
 *
 * Provides an object abstraction away from the DB for IPBlocks
 *
 * @author		Brandon Philips
 * @version		$Id: ip_block.php,v 1.9 2004/05/26 20:58:56 philips Exp $
 * @package network_model
 */
class IPBlock {
	var $_id;
	/**
	 * Start ip of block
	 * @var		int
	 * @access	private
	 */
	var $_start;
	/**
	 * End ip of block
	 * @var		int
	 * @access  private	
	 */
	var $_end;
	/**
	 * IPBlock enabled or not 
	 * @var		bool	true - enabled
	 * @access	private
	 */
	var $_enabled;
	/**
	 * Human readable name of $_name;
	 * @var		string
	 * @access	private
	 */
	var $_name;

	/**
	* Contructor for the IPBlock class 
	*
	* This constructor can be used in one of two ways:
	* - If the id passed into the constructor is 0 then you are creating 
	* 	a new block.  
	* - If it is non-zero than it assumes you are creating a new object of 
	* 	an exiting IP block
	*
	* @return	mixed	 Description
	* @access	public
	* @param	int		$id 		DB ID of the IPBlock
	* @param	int		$start		@see $this->_new_block
	* @param	int		$end		@see $this->_new_block
	* @param	int		$name		@see $this->_new_block
	* @param	int		$enabled	@see $this->_new_block
	*/
	function IPBlock ($id = null, 
						$start = null, $end = null, $name = null, $enabled = null ) { 
		global $conf;
		if ($id)  { // Propogate information from server
			$sql = "SELECT * FROM ip_blocks WHERE id = $id";
			$db_results = mysql_query($sql, dbh());

			// Check to ensure the id exists, if not die.
			$r = mysql_fetch_object($db_results);

			if (!$r) {
				trigger_error("No IP block with id = $id", E_USER_ERROR);
			}	

			$this->_id		= $id;
			$this->_start 	= $r->start;
			$this->_end 	= $r->end;
			$this->_name 	= $r->name;
			$this->_enabled	= $r->enabled;

			if ($ip_int) {
				$info = $this->get_info();
				$this->subnet	= new Subnet($info->id);
			} 
			
		} 
		else if ($start != null && $end != null && $name != null 
					&& $enabled !=null)	{
			// Create the block if an id was not passed
 			$this->_new_block($start, $end, $name, $enabled);
		}	
	}

	/**
	* Inserts a new IP Block into the DB
	* 
	* @access	private
	*/
	function _new_block($start,$end,$name,$enabled) {
		// Insert this new block
		if (!$this->find_ip_block($start,$end,$name)) {
			$sql = "INSERT INTO ip_blocks (start,end,name,enabled) VALUES ('$start','$end','$name','$enabled')";
			$db_results = mysql_query($sql, dbh());
		}
	} 

	// Check to see if IP Block Exists
	function find_ip_block($start,$end,$name) {
		global $conf;

		// Considers it a duplicate if name the same of if the ips are already in the db
		$sql = "SELECT id FROM ip_blocks WHERE ( start<='$start' AND end>='$end' ) OR name='$name'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);

		return $results->id;

	} //check_ip_block


	//Check the IP blocks to make sure said IP Int exists
	function ip_exists($ip_int) {
		global $conf;

		$sql = "SELECT * FROM ip_blocks WHERE start<='$ip_int' AND end>='$ip_int' AND enabled='1'";
		$db_results = mysql_query($sql);

		if ($r = mysql_fetch_object($db_results)) {
			return true;
		}

		return false;

	} //ip_exists

	/*!
		@function delete_block	
		@discussion deletes a ip_block, must be full admin
	*/
	function delete() {
		global $conf,$user;

		if ($user->is_admin) { 
			$sql = "DELETE FROM ip_blocks WHERE id='$this->_id'";
			$db_results = mysql_query($sql, $conf['dbh']);
		}
		else {
			$conf['ui']->show_access_denied();
		}
	} // delete_block

	/**
	* @return	int	 the start IP for this block as an int
	*/
	function get_start() {
		return $this->_start;
	}

	/**
	* @return	int  the end IP for this block as an int
	*/
	function get_end() {
		return $this->_end;
	}

	function get_name() {
		return $this->_name;
	}

	function get_id() {
		return $this->_id;
	}

	function is_enabled() {
		return $this->_enabled;
	}

	function set_enabled($enabled) {
		$this->_set_item('enabled',$enabled);
	}

	function set_start($start) {
		$this->_set_item('start',$start);
	} 

	function set_end($end) {
		$this->_set_item('end',$end);
	}

	function set_name($name) { 
		$this->_set_item('name',$name);
	}

	function _set_item($field,$value) {
		global $conf, $user;

		// just for safety's sake
		if ($user->is_admin) { 
			$sql = "UPDATE ip_blocks SET $field='$value' WHERE id='$this->_id'";
			$db_results = mysql_query($sql, dbh());
		} // is admin
	} 

	function get_all_ip_blocks() {
		global $conf;

		$sql = "SELECT id FROM ip_blocks";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) { 
			$results[] = new IPBlock($r->id);
		}

		return $results;

	} // get_ip_blocks


	// Accessor functions -- things only used by this class or for
	//    debugging purposes
	function _show () {
		print ("IP: ip_int -> $this->ip_int, ip_addr -> $this->ip_addr, ");
		print_r(get_object_vars($this->subnet));
		print ("end IP<br>\n");
	}

	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
}

