<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: show_option.inc,v 1.13 2003/10/16 00:04:20 vollmerk Exp $
 $Source: /tmp/maintain/templates/show_option.inc,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Options Template
	Show a single DHCP option for a specific subnet or workgroup.

*/

if ($type == 'subnet') {
	$object = new Subnet($object_id);
}
elseif ($type == 'workgroup') { 
	$object = new Workgroup($object_id);
}
elseif ($type == 'host') {
	$object = new Host($object_id);
}
?>

<p class="header2">Update a DHCP Option for the <?= $object->name . " " . $type; ?></p>

<?
$items = array();
$items[] = "<a href=\"" . $conf['web_path'] . "/" . $type . ".php?action=edit&amp;" . $type . "_id=$type_id\">View the $type associated with this Option</a>";
$items[] = "<a href=\"" . $conf['web_path'] . "/option.php?action=show_options&amp;object_id=$object_id&amp;type=$type\">View DHCP Options for this $type</a>";
$conf['ui']->display_top_widget($items);
?>

<? if ( $conf['error']->get_status('option_top') ) { ?>
<p><? $conf['error']->show_message('option_top'); ?></p>
<? } ?>
<? show_template('tborder'); ?>

<form name="edit_option" style="Display:inline" enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/option.php">
<table border="0" cellpadding="2" cellspacing="0" width="100%">
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->title('options_value'); ?>"><? $conf['help']->show_link('options_value'); ?>Option Value</td>
	<td>
		<input name="value" value="<?= $option->value; ?>" />
		<? $conf['error']->show_message('option_value'); ?>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->title('dhcp_option'); ?>"><? $conf['help']->show_link('dhcp_option'); ?>DHCP Option: </td>
        <td><? $conf['ui']->show_dhcp_option_select($option->dhcp_option,"dhcp_option"); ?></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td title="<? $conf['help']->title('dhcp_scope'); ?>"><? $conf['help']->show_link('dhcp_scope'); ?>Scope:</td>
	<td>
        	<select name="scope">
	                 <option value="<?= $type; ?>" <? if ($scope == $type) { echo "SELECTED"; } ?>>Local</option>
		         <option value="host" <? if ($scope == 'host') { echo "SELECTED"; } ?>>Host</option>
	         </select>
	         <? $conf['error']->show_message('scope'); ?>
	</td>
</tr>
<tr align="left" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td>&nbsp;</td>
	<td>
		<input type="submit" value="Update Option" />&nbsp;&nbsp;
		<input type="hidden" name="action" value="update_option" />
		<input type="submit" name="action" value="Cancel" />
		<input type="hidden" name="option_id" value="<?= $option->id; ?>" />
		<input type="hidden" name="type" value="<?= $type ?>" />
		<input type="hidden" name="object_id" value="<?= $object_id; ?>" />
		<input type="hidden" name="zone_id" value="<?= $zone_id; ?>" />
	</td>
</tr>
</table>
</form>

<? show_template('bborder'); ?>
